
// Copyright (c) 1999 By Symbian Ltd. All Rights Reserved.

// $Revision: 1.1 $

package com.symbian.javax.comm;

public class EpocCommDriver
			 implements
				 javax.comm.CommDriver
{
	public javax.comm.CommPort	getCommPort(String name, int type)
	{
		javax.comm.CommPort	port;
		int					portHandle;
		
		if (handle == 0)
		{
			return null;
		}
		port = null;
		try
		{
			switch (type)
			{
				case javax.comm.CommPortIdentifier.PORT_SERIAL:

					portHandle = _openSerialPort(handle, name + ":");
					if (handle != 0)
					{
						port = new EpocSerialPort(name, portHandle);
					}
					break;

			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		return port;
	}

	public void initialize()
	{
		handle = _init();
	}

	private void addSerialPort(String name)
	{
		javax.comm.CommPortIdentifier.addPortName(
			mapNativePortName(name), 
			javax.comm.CommPortIdentifier.PORT_SERIAL,
			this);
	}

	private String mapNativePortName(String nativePortName)
	{
		int	nMapEntries;

		nMapEntries = portNameMap.length;
		for (int i = 0; i < nMapEntries; i++)
		{
			if (nativePortName.equals(portNameMap[i][0]))
			{
				return portNameMap[i][1];
			}
		}
		return nativePortName;
	}

	private String mapPortName(String portName)
	{
		int	nMapEntries;

		nMapEntries = portNameMap.length;
		for (int i = 0; i < nMapEntries; i++)
		{
			if (portName.equals(portNameMap[i][1]))
			{
				return portNameMap[i][0];
			}
		}
		return portName;
	}

	private native int _init();
	private native int _openSerialPort(int handle, String portName);

	private int	handle;

	static
	{
		System.loadLibrary("jcomm");
	}

	private final static String[][] portNameMap = {

		{ "COMM::0", "COM1" },
		{ "COMM::1", "COM2" },
		{ "IrCOMM::0", "IRCOM1" }

	};
}
